package com.ejie.ab79.dao.AB63;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.AB63.TiposEstablecimiento;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableRequestDto;

/**
 * TiposEstablecimientoDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class TiposEstablecimientoDaoImpl implements TiposEstablecimientoDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDTIPOESTABLECIMIENTO", "DESCRIPCIONCASTELLANO",
			"BAJA", "DESCRIPCIONEUSKERA", "ORDENACION", "TIPIFICACION"};

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<TiposEstablecimiento> rwMap = new RowMapper<TiposEstablecimiento>() {
		public TiposEstablecimiento mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new TiposEstablecimiento(resultSet.getString("IDTIPOESTABLECIMIENTO"),
					resultSet.getString("DESCRIPCIONCASTELLANO"), resultSet.getInt("BAJA"), resultSet.getString("DESCRIPCIONEUSKERA"),
					resultSet.getString("ORDENACION"), resultSet.getString("TIPIFICACION"));
		}
	};

	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	@Transactional(readOnly = true)
	public List<TiposEstablecimiento> findAll(TiposEstablecimiento tiposestablecimiento,
			TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_TIPO_ESTABLECIMIENTO IDTIPOESTABLECIMIENTO,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.BAJA BAJA, "
				+ " t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.ORDENACION ORDENACION, t1.TIPIFICACION TIPIFICACION ");
		query.append(" FROM TIPOS_ESTABLECIMIENTO t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(tiposestablecimiento);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query,
					TiposEstablecimientoDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	private Map<String, ?> getWhereMap(TiposEstablecimiento tiposestablecimiento) {

		StringBuilder where = new StringBuilder(TiposEstablecimientoDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (tiposestablecimiento != null && tiposestablecimiento.getIdTipoEstablecimiento() != null) {
			where.append(" AND t1.ID_TIPO_ESTABLECIMIENTO = ?");
			params.add(tiposestablecimiento.getIdTipoEstablecimiento());
		}
		if (tiposestablecimiento != null && tiposestablecimiento.getDescripcionCastellano() != null) {
			where.append(" AND t1.DESCRIPCION_CASTELLANO = ?");
			params.add(tiposestablecimiento.getDescripcionCastellano());
		}
		if (tiposestablecimiento != null && tiposestablecimiento.getBaja() != null) {
			where.append(" AND t1.BAJA = ?");
			params.add(tiposestablecimiento.getBaja());
		}
		if (tiposestablecimiento != null && tiposestablecimiento.getDescripcionEuskera() != null) {
			where.append(" AND t1.DESCRIPCION_EUSKERA = ?");
			params.add(tiposestablecimiento.getDescripcionEuskera());
		}
		if (tiposestablecimiento != null && tiposestablecimiento.getOrdenacion() != null) {
			where.append(" AND t1.ORDENACION = ?");
			params.add(tiposestablecimiento.getOrdenacion());
		}
		if (tiposestablecimiento != null && tiposestablecimiento.getTipificacion() != null) {
			where.append(" AND t1.TIPIFICACION = ?");
			params.add(tiposestablecimiento.getTipificacion());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}

	public static final int STRING_BUILDER_INIT = 4096;
}
